var firebreath = {}; //global object
var ports = {};
var brw = typeof browser != "undefined"  ? browser : chrome;
var rt = brw.runtime;

rt.onConnect.addListener(function(scriptPort) {
    var parts = scriptPort.name.split("|");
    var name = parts[0];
    var hostName = parts[1];
    var hostPort = rt.connectNative(hostName);
    var self = ports[name] = {
        script: scriptPort,
        host: hostPort
    };
    scriptPort.onMessage.addListener(function(msg) {
        // Message from the content script (from the page),
        // post it to the native message host
        hostPort.postMessage(msg);
    });
    hostPort.onMessage.addListener(function(msg) {
        // Message from the native message host,
        // post it to the content script (to the page)
        scriptPort.postMessage(msg);
    });
    scriptPort.onDisconnect.addListener(function() {
        // The script disconnected, so disconnect the hostPort
        hostPort.disconnect();
    });
    hostPort.onDisconnect.addListener(function() {
        // The host (native message host) disconnected, so disconnect
        // the script port. If there is an error, report it first
        if (rt.lastError) {
            scriptPort.postMessage({error: "Disconnected", message: rt.lastError.message});
            console.warn("Disconnected:", rt.lastError.message);
        } else {
            scriptPort.postMessage({error: "Disconnected"});
        }
        scriptPort.disconnect();
    });
});
